Index: issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp	(revision 20644)
+++ issm/trunk-jpl/src/c/analyses/StressbalanceAnalysis.cpp	(revision 20645)
@@ -41,12 +41,12 @@
 
 	/*Fetch parameters: */
-	iomodel->Constant(&g,ConstantsGEnum);
-	iomodel->Constant(&rho_ice,MaterialsRhoIceEnum);
-	iomodel->Constant(&FSreconditioning,StressbalanceFSreconditioningEnum);
-	iomodel->Constant(&isSIA,FlowequationIsSIAEnum);
-	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
-	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
-	iomodel->Constant(&isHO,FlowequationIsHOEnum);
-	iomodel->Constant(&isFS,FlowequationIsFSEnum);
+	iomodel->FindConstant(&g,ConstantsGEnum);
+	iomodel->FindConstant(&rho_ice,MaterialsRhoIceEnum);
+	iomodel->FindConstant(&FSreconditioning,StressbalanceFSreconditioningEnum);
+	iomodel->FindConstant(&isSIA,FlowequationIsSIAEnum);
+	iomodel->FindConstant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->FindConstant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->FindConstant(&isHO,FlowequationIsHOEnum);
+	iomodel->FindConstant(&isFS,FlowequationIsFSEnum);
 
 	/*Now, is the flag macayaealHO on? otherwise, do nothing: */
@@ -63,8 +63,8 @@
 
 		/*Get finite element type*/
-		if(isSSA)       iomodel->Constant(&finiteelement,FlowequationFeSSAEnum);
+		if(isSSA)       iomodel->FindConstant(&finiteelement,FlowequationFeSSAEnum);
 		else if(isL1L2) finiteelement = P1Enum;
-		else if(isHO)   iomodel->Constant(&finiteelement,FlowequationFeHOEnum);
-		else if(isFS){  iomodel->Constant(&finiteelement,FlowequationFeFSEnum);
+		else if(isHO)   iomodel->FindConstant(&finiteelement,FlowequationFeHOEnum);
+		else if(isFS){  iomodel->FindConstant(&finiteelement,FlowequationFeFSEnum);
 			/*Deduce velocity interpolation from finite element*/
 			switch(finiteelement){
@@ -451,9 +451,9 @@
 
 	/*Fetch parameters: */
-	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
-	iomodel->Constant(&isFS,FlowequationIsFSEnum);
-	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
-	iomodel->Constant(&isHO,FlowequationIsHOEnum);
-	iomodel->Constant(&numrifts,RiftsNumriftsEnum);
+	iomodel->FindConstant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->FindConstant(&isFS,FlowequationIsFSEnum);
+	iomodel->FindConstant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->FindConstant(&isHO,FlowequationIsHOEnum);
+	iomodel->FindConstant(&numrifts,RiftsNumriftsEnum);
 
 	/*Now, is the flag macayaealHO on? otherwise, do nothing: */
@@ -507,8 +507,8 @@
 
 	/*Fetch parameters: */
-	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
-	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
-	iomodel->Constant(&isHO,FlowequationIsHOEnum);
-	iomodel->Constant(&isFS,FlowequationIsFSEnum);
+	iomodel->FindConstant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->FindConstant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->FindConstant(&isHO,FlowequationIsHOEnum);
+	iomodel->FindConstant(&isFS,FlowequationIsFSEnum);
 
 	/*Now, check that we have non SIA elements */
@@ -527,5 +527,5 @@
 		if(isSSA){
 			approximation=SSAApproximationEnum;
-			iomodel->Constant(&finiteelement,FlowequationFeSSAEnum);
+			iomodel->FindConstant(&finiteelement,FlowequationFeSSAEnum);
 		}
 		else if(isL1L2){
@@ -535,9 +535,9 @@
 		else if(isHO){
 			approximation = HOApproximationEnum;
-			iomodel->Constant(&finiteelement,FlowequationFeHOEnum);
+			iomodel->FindConstant(&finiteelement,FlowequationFeHOEnum);
 		}
 		else if(isFS){
 			approximation = FSApproximationEnum;
-			iomodel->Constant(&finiteelement,FlowequationFeFSEnum);
+			iomodel->FindConstant(&finiteelement,FlowequationFeFSEnum);
 		}
 		iomodel->FetchData(3,FlowequationBorderSSAEnum,FlowequationVertexEquationEnum,StressbalanceReferentialEnum);
@@ -681,13 +681,13 @@
 
 	/*Fetch constants needed: */
-	iomodel->Constant(&isSSA,FlowequationIsSSAEnum);
-	iomodel->Constant(&isL1L2,FlowequationIsL1L2Enum);
-	iomodel->Constant(&isHO,FlowequationIsHOEnum);
-	iomodel->Constant(&isFS,FlowequationIsFSEnum);
-	iomodel->Constant(&control_analysis,InversionIscontrolEnum);
-	iomodel->Constant(&dakota_analysis,QmuIsdakotaEnum);
-	iomodel->Constant(&materials_type,MaterialsEnum);
-	iomodel->Constant(&ismovingfront,TransientIsmovingfrontEnum);
-	iomodel->Constant(&frictionlaw,FrictionLawEnum);
+	iomodel->FindConstant(&isSSA,FlowequationIsSSAEnum);
+	iomodel->FindConstant(&isL1L2,FlowequationIsL1L2Enum);
+	iomodel->FindConstant(&isHO,FlowequationIsHOEnum);
+	iomodel->FindConstant(&isFS,FlowequationIsFSEnum);
+	iomodel->FindConstant(&control_analysis,InversionIscontrolEnum);
+	iomodel->FindConstant(&dakota_analysis,QmuIsdakotaEnum);
+	iomodel->FindConstant(&materials_type,MaterialsEnum);
+	iomodel->FindConstant(&ismovingfront,TransientIsmovingfrontEnum);
+	iomodel->FindConstant(&frictionlaw,FrictionLawEnum);
 
 	/*return if no processing required*/
@@ -706,8 +706,8 @@
 	/*Get finite element type*/
 	if(!iscoupling){
-		if(isSSA)       iomodel->Constant(&finiteelement,FlowequationFeSSAEnum);
+		if(isSSA)       iomodel->FindConstant(&finiteelement,FlowequationFeSSAEnum);
 		else if(isL1L2) finiteelement = P1Enum;
-		else if(isHO)   iomodel->Constant(&finiteelement,FlowequationFeHOEnum);
-		else if(isFS)   iomodel->Constant(&finiteelement,FlowequationFeFSEnum);
+		else if(isHO)   iomodel->FindConstant(&finiteelement,FlowequationFeHOEnum);
+		else if(isFS)   iomodel->FindConstant(&finiteelement,FlowequationFeFSEnum);
 		for(int i=0;i<iomodel->numberofelements;i++){
 			finiteelement_list[i]=finiteelement;
@@ -773,5 +773,5 @@
 	}
 	/*LATH parameters*/
-	iomodel->Constant(&fe_FS,FlowequationFeFSEnum);
+	iomodel->FindConstant(&fe_FS,FlowequationFeFSEnum);
 	if(fe_FS==LATaylorHoodEnum || fe_FS==LACrouzeixRaviartEnum){
 		InputUpdateFromConstantx(elements,0.,SigmaNNEnum);
@@ -790,5 +790,5 @@
 			break;
 		case 3:
-			iomodel->Constant(&FrictionCoupling,FrictionCouplingEnum);
+			iomodel->FindConstant(&FrictionCoupling,FrictionCouplingEnum);
 			iomodel->FetchDataToInput(elements,FrictionCEnum);
 			iomodel->FetchDataToInput(elements,FrictionAsEnum);
@@ -862,5 +862,5 @@
 
 	/*XTH LATH parameters*/
-	iomodel->Constant(&fe_FS,FlowequationFeFSEnum);
+	iomodel->FindConstant(&fe_FS,FlowequationFeFSEnum);
 	if(fe_FS==XTaylorHoodEnum || fe_FS==LATaylorHoodEnum || fe_FS==LACrouzeixRaviartEnum){
 		parameters->AddObject(iomodel->CopyConstantObject(AugmentedLagrangianREnum));
@@ -869,5 +869,5 @@
 	}
 
-	iomodel->Constant(&materials_type,MaterialsEnum);
+	iomodel->FindConstant(&materials_type,MaterialsEnum);
 	if(materials_type==MatdamageiceEnum){
 		parameters->AddObject(iomodel->CopyConstantObject(DamageLawEnum));
@@ -884,5 +884,5 @@
 	/*Deal with friction parameters*/
 	int frictionlaw;
-	iomodel->Constant(&frictionlaw,FrictionLawEnum);
+	iomodel->FindConstant(&frictionlaw,FrictionLawEnum);
 	if(frictionlaw==4 || frictionlaw==6) parameters->AddObject(iomodel->CopyConstantObject(FrictionGammaEnum));
 	if(frictionlaw==3) parameters->AddObject(iomodel->CopyConstantObject(FrictionCouplingEnum));