Index: issm/trunk-jpl/src/m/modules/BamgConvertMesh.py
===================================================================
--- issm/trunk-jpl/src/m/modules/BamgConvertMesh.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/BamgConvertMesh.py	(revision 20909)
@@ -6,5 +6,5 @@
 
 	Usage:
-		[bamggeom, bamgmesh] = BamgConvertMesh(index, x, y)
+		bamggeom, bamgmesh = BamgConvertMesh(index, x, y)
 		index: index of the mesh
 		x,y: coordinates of the nodes
@@ -12,6 +12,6 @@
 	
 	#Call mex module
-	[bamggeom, bamgmesh] = BamgConvertMesh_python(index,x,y);
+	bamggeom, bamgmesh = BamgConvertMesh_python(index,x,y)
 
 	#return
-	return [bamggeom, bamgmesh]
+	return bamggeom, bamgmesh
Index: issm/trunk-jpl/src/m/modules/BamgMesher.py
===================================================================
--- issm/trunk-jpl/src/m/modules/BamgMesher.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/BamgMesher.py	(revision 20909)
@@ -6,5 +6,5 @@
 
 	Usage:
-		[bamgmesh,bamggeom] = BamgMesher(bamgmesh,bamggeom,bamgoptions);
+		bamgmesh,bamggeom = BamgMesher(bamgmesh,bamggeom,bamgoptions);
 
 	bamgmesh: input bamg mesh
@@ -14,6 +14,6 @@
 	
 	#Call mex module
-	[bamgmesh, bamggeom] = BamgMesher_python(bamgmesh, bamggeom, bamgoptions);
+	bamgmesh, bamggeom = BamgMesher_python(bamgmesh, bamggeom, bamgoptions)
 
 	#return
-	return [bamgmesh, bamggeom]
+	return bamgmesh, bamggeom
Index: issm/trunk-jpl/src/m/modules/BamgTriangulate.py
===================================================================
--- issm/trunk-jpl/src/m/modules/BamgTriangulate.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/BamgTriangulate.py	(revision 20909)
@@ -13,5 +13,5 @@
 
 	# Call mex module
-	index = BamgTriangulate_python(x,y);
+	index = BamgTriangulate_python(x,y)
 	# return
 	return index
Index: issm/trunk-jpl/src/m/modules/ContourToMesh.py
===================================================================
--- issm/trunk-jpl/src/m/modules/ContourToMesh.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/ContourToMesh.py	(revision 20909)
@@ -24,8 +24,12 @@
 	"""
 	#Call mex module
-	[in_nod,in_elem] = ContourToMesh_python(index,x,y,contourname,interptype,edgevalue);
+	in_nod,in_elem = ContourToMesh_python(index,x,y,contourname,interptype,edgevalue)
 
 	if interptype=='element':
-		return [in_elem,[]]
+		return in_elem
+	elif interptype=='node':
+		return in_nod
+	elif interptype=='element and node':
+		return in_nod,in_elem
 	else:
-		return [in_nod,in_elem]
+		raise TypeError('interpolation type "{}" not supported yet'.format(interptype))
Index: issm/trunk-jpl/src/m/modules/ContourToNodes.py
===================================================================
--- issm/trunk-jpl/src/m/modules/ContourToNodes.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/ContourToNodes.py	(revision 20909)
@@ -15,5 +15,5 @@
 
 	#Call mex module
-	[flags] = ContourToNodes_python(x,y,contourname,edgevalue);
+	flags = ContourToNodes_python(x,y,contourname,edgevalue)
 
 	#return
Index: issm/trunk-jpl/src/m/modules/ElementConnectivity.py
===================================================================
--- issm/trunk-jpl/src/m/modules/ElementConnectivity.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/ElementConnectivity.py	(revision 20909)
@@ -9,5 +9,5 @@
 	"""
 	#Call mex module
-	elementconnectivity = ElementConnectivity_python(elements,nodeconnectivity);
+	elementconnectivity = ElementConnectivity_python(elements,nodeconnectivity)
 	
 	#Return
Index: issm/trunk-jpl/src/m/modules/EnumToString.py
===================================================================
--- issm/trunk-jpl/src/m/modules/EnumToString.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/EnumToString.py	(revision 20909)
@@ -6,9 +6,9 @@
 
 		Usage:
-			enumstring = EnumToString(enum);
+			enumstring = EnumToString(enum)
 	"""
 
 	# Call mex module
-	enumstring = EnumToString_python(enum);
+	enumstring = EnumToString_python(enum)
 
 	# Return
Index: issm/trunk-jpl/src/m/modules/InterpFromGridToMesh.py
===================================================================
--- issm/trunk-jpl/src/m/modules/InterpFromGridToMesh.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/InterpFromGridToMesh.py	(revision 20909)
@@ -18,5 +18,5 @@
 	"""
 	# Call mex module
-	data_mesh=InterpFromGridToMesh_python(x,y,data,x_mesh,y_mesh,default_value);
+	data_mesh=InterpFromGridToMesh_python(x,y,data,x_mesh,y_mesh,default_value)
 	# Return
 	return data_mesh
Index: issm/trunk-jpl/src/m/modules/InterpFromMeshToGrid.py
===================================================================
--- issm/trunk-jpl/src/m/modules/InterpFromMeshToGrid.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/InterpFromMeshToGrid.py	(revision 20909)
@@ -15,5 +15,5 @@
 	"""
 	# Call mex module
-	[x_m,y_m,griddata]=InterpFromMeshToGrid_python(index,x,y,data,xmin,ymax,xposting,yposting,nlines,ncols,default_value);
+	x_m,y_m,griddata=InterpFromMeshToGrid_python(index,x,y,data,xmin,ymax,xposting,yposting,nlines,ncols,default_value)
 	# Return
-	return [x_m,y_m,griddate];
+	return x_m,y_m,griddate
Index: issm/trunk-jpl/src/m/modules/InterpFromMeshToMesh2d.py
===================================================================
--- issm/trunk-jpl/src/m/modules/InterpFromMeshToMesh2d.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/InterpFromMeshToMesh2d.py	(revision 20909)
@@ -23,5 +23,5 @@
 	"""
 	# Call mex module
-	data_interp = InterpFromMeshToMesh2d_python(*args);
+	data_interp = InterpFromMeshToMesh2d_python(*args)
 	# Return
 	return data_interp
Index: issm/trunk-jpl/src/m/modules/InterpFromMeshToMesh3d.py
===================================================================
--- issm/trunk-jpl/src/m/modules/InterpFromMeshToMesh3d.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/InterpFromMeshToMesh3d.py	(revision 20909)
@@ -17,6 +17,7 @@
       md.initialization.temperature=InterpFromMeshToMesh3d(index,x,y,z,temperature,md.mesh.x,md.mesh.y,md.mesh.z,253);
 	"""
-# Call mex module
-data_prime = InterpFromMeshToMesh3d_python(index,x,y,z,data,x_prime,y_prime,z_prime,default_value);
-# Return
-return data_prime
+	# Call mex module
+	data_prime = InterpFromMeshToMesh3d_python(index,x,y,z,data,x_prime,y_prime,z_prime,default_value)
+	
+	# Return
+	return data_prime
Index: issm/trunk-jpl/src/m/modules/IssmConfig.py
===================================================================
--- issm/trunk-jpl/src/m/modules/IssmConfig.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/IssmConfig.py	(revision 20909)
@@ -10,6 +10,6 @@
 
 	# Call mex module
-	value = IssmConfig_python(string);
+	value = IssmConfig_python(string)
 	# Return
-	return value;
+	return value
 
Index: issm/trunk-jpl/src/m/modules/MeshProfileIntersection.py
===================================================================
--- issm/trunk-jpl/src/m/modules/MeshProfileIntersection.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/MeshProfileIntersection.py	(revision 20909)
@@ -18,5 +18,5 @@
 	
 	# Call mex module
-	[segments] = MeshProfileIntersection_python(index,x,y,filename);
+	segments = MeshProfileIntersection_python(index,x,y,filename)
 
 	# Return
Index: issm/trunk-jpl/src/m/modules/NodeConnectivity.py
===================================================================
--- issm/trunk-jpl/src/m/modules/NodeConnectivity.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/NodeConnectivity.py	(revision 20909)
@@ -9,7 +9,7 @@
 	"""
 	# Call mex module
-	connectivity = NodeConnectivity_python(elements,numnodes);
+	connectivity = NodeConnectivity_python(elements,numnodes)
 
 	# Return
-	return connectivity;
+	return connectivity
 
Index: issm/trunk-jpl/src/m/modules/StringToEnum.py
===================================================================
--- issm/trunk-jpl/src/m/modules/StringToEnum.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/StringToEnum.py	(revision 20909)
@@ -10,5 +10,5 @@
 	
 	# Call mex module
-	enum = StringToEnum_python(string);
+	enum = StringToEnum_python(string)
 	# Return
 	return enum
Index: issm/trunk-jpl/src/m/modules/TriMesh.py
===================================================================
--- issm/trunk-jpl/src/m/modules/TriMesh.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/TriMesh.py	(revision 20909)
@@ -16,6 +16,6 @@
 	"""
 	# Call mex module
-	[index,x,y,segments,segmentmarkers]=TriMesh_python(domainoutlinefilename,rifts,mesh_area);
+	index,x,y,segments,segmentmarkers=TriMesh_python(domainoutlinefilename,rifts,mesh_area)
 	# Return
-	return [index,x,y,segments,segmentmarkers]
+	return index,x,y,segments,segmentmarkers
 
Index: issm/trunk-jpl/src/m/modules/TriMeshProcessRifts.py
===================================================================
--- issm/trunk-jpl/src/m/modules/TriMeshProcessRifts.py	(revision 20880)
+++ issm/trunk-jpl/src/m/modules/TriMeshProcessRifts.py	(revision 20909)
@@ -12,5 +12,5 @@
 	"""
 	# Call mex module
-	[index2,x2,y2,segments2,segmentmarkers2,rifts2] = TriMeshProcessRifts_python(index1,x1,y1,segments1,segmentmarkers1);
+	index2,x2,y2,segments2,segmentmarkers2,rifts2 = TriMeshProcessRifts_python(index1,x1,y1,segments1,segmentmarkers1)
 	# Return
-	return [index2,x2,y2,segments2,segmentmarkers2,rifts2] 
+	return index2,x2,y2,segments2,segmentmarkers2,rifts2