Index: issm/trunk-jpl/src/c/classes/IoModel.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/IoModel.cpp	(revision 20940)
+++ issm/trunk-jpl/src/c/classes/IoModel.cpp	(revision 20943)
@@ -733,112 +733,112 @@
 				ISSM_MPI_Bcast(&record_length,1,ISSM_MPI_INT,0,IssmComm::GetComm());  
 				switch(record_code){
-				case 1: 
-					/*boolean. get it from cpu 0 */
-					ISSM_MPI_Bcast(&booleanint,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
-
-					/*create BoolParam: */
-					this->AddConstant(new IoConstant((bool)booleanint,record_name)); //cast to a boolean
-					break;
-
-				case 2:
-					/*integer. get it from cpu 0 */
-					ISSM_MPI_Bcast(&integer,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
-
-					/*create IntParam: */
-					this->AddConstant(new IoConstant(integer,record_name));
-					break;
-				case 3:
-					/*scalar. get it from cpu 0 */
-					  {
-						/*IssmDouble, check whether it is already there (from "declare independents")*/
-						bool exists = false;
-						vector<IoConstant*>::iterator iter;
-						for(iter=constants.begin();iter<constants.end();iter++){
-							IoConstant* ioconstant=*iter;
-							if(strcmp(ioconstant->name,record_name)==0){
-								exists = true;
-								break;
+					case 1: 
+						/*boolean. get it from cpu 0 */
+						ISSM_MPI_Bcast(&booleanint,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
+
+						/*create BoolParam: */
+						this->AddConstant(new IoConstant((bool)booleanint,record_name)); //cast to a boolean
+						break;
+
+					case 2:
+						/*integer. get it from cpu 0 */
+						ISSM_MPI_Bcast(&integer,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
+
+						/*create IntParam: */
+						this->AddConstant(new IoConstant(integer,record_name));
+						break;
+					case 3:
+						/*scalar. get it from cpu 0 */
+						  {
+							/*IssmDouble, check whether it is already there (from "declare independents")*/
+							bool exists = false;
+							vector<IoConstant*>::iterator iter;
+							for(iter=constants.begin();iter<constants.end();iter++){
+								IoConstant* ioconstant=*iter;
+								if(strcmp(ioconstant->name,record_name)==0){
+									exists = true;
+									break;
+								}
 							}
+							if(!exists){
+								ISSM_MPI_Bcast(&pscalar,1,ISSM_MPI_PDOUBLE,0,IssmComm::GetComm());
+								scalar=pscalar;
+								/*create DoubleParam: */
+								this->AddConstant(new IoConstant(scalar,record_name));
+							}
+						  }
+						break;
+					case 4: 
+						ISSM_MPI_Bcast(&string_size,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
+						if(string_size){
+							string=xNew<char>((string_size+1));
+							string[string_size]='\0';
+
+							/*Read string from cpu 0: */
+							ISSM_MPI_Bcast(string,string_size,ISSM_MPI_CHAR,0,IssmComm::GetComm()); 
 						}
-						if(!exists){
-							ISSM_MPI_Bcast(&pscalar,1,ISSM_MPI_PDOUBLE,0,IssmComm::GetComm());
-							scalar=pscalar;
-							/*create DoubleParam: */
-							this->AddConstant(new IoConstant(scalar,record_name));
+						else{
+							string=xNew<char>(1);
+							string[0]='\0';
 						}
-					  }
-					break;
-				case 4: 
-					ISSM_MPI_Bcast(&string_size,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
-					if(string_size){
-						string=xNew<char>((string_size+1));
-						string[string_size]='\0';
-
-						/*Read string from cpu 0: */
-						ISSM_MPI_Bcast(string,string_size,ISSM_MPI_CHAR,0,IssmComm::GetComm()); 
-					}
-					else{
-						string=xNew<char>(1);
-						string[0]='\0';
-					}
-					if(strcmp(record_name,"md.flowequation.fe_SSA")==0){
-						this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
-					} else if(strcmp(record_name,"md.flowequation.fe_HO")==0){
-						this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
-					} else if(strcmp(record_name,"md.flowequation.fe_FS")==0){
-						this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
-					} else if(strcmp(record_name,"md.groundingline.migration")==0){
-						this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
-					} else if(strcmp(record_name,"md.masstransport.hydrostatic_adjustment")==0){
-						this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
-					} else {
-						/*Add string to parameters: */
-						this->AddConstant(new IoConstant(string,record_name));
-					}
-
-					/*Free string*/
-					xDelete<char>(string);
-
-					break;
-				case 5: break; //do nothing. not interested in this type of data, which is memory intensive.
-				case 6: break; //do nothing. not interested in this type of data, which is memory intensive.
-				case 7: break; //do nothing. not interested in this type of data, which is memory intensive.
-				case 8: break; //do nothing. not interested in this type of data, which is memory intensive.
-				case 9:
-					ISSM_MPI_Bcast(&numstrings,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
-					/*Now allocate string array: */
-					if(numstrings){
-						strings=xNew<char*>(numstrings);
-						for(int i=0;i<numstrings;i++)strings[i]=NULL;
-
-						/*Go through strings, and read: */
-						for(int i=0;i<numstrings;i++){
-
-							ISSM_MPI_Bcast(&string_size,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
-							if(string_size){
-								string=xNew<char>((string_size+1));
-								string[string_size]='\0';
-								ISSM_MPI_Bcast(string,string_size,ISSM_MPI_CHAR,0,IssmComm::GetComm()); 
-							}
-							else{
-								string=xNew<char>(1);
-								string[0]='\0';
-							}
-							strings[i]=string;
+						if(strcmp(record_name,"md.flowequation.fe_SSA")==0){
+							this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
+						} else if(strcmp(record_name,"md.flowequation.fe_HO")==0){
+							this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
+						} else if(strcmp(record_name,"md.flowequation.fe_FS")==0){
+							this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
+						} else if(strcmp(record_name,"md.groundingline.migration")==0){
+							this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
+						} else if(strcmp(record_name,"md.masstransport.hydrostatic_adjustment")==0){
+							this->AddConstant(new IoConstant(StringToEnumx(string),record_name));
+						} else {
+							/*Add string to parameters: */
+							this->AddConstant(new IoConstant(string,record_name));
 						}
-					}
-
-					/*Add strings to parameters: */
-					this->AddConstant(new IoConstant(strings,numstrings,record_name));
-
-					/*Free string*/
-					for(int i=0;i<numstrings;i++) xDelete<char>(strings[i]);
-					xDelete<char*>(strings);
-					break;
-				default: 
-					_error_("unknown record type:" << record_code); 
-					break;
+
+						/*Free string*/
+						xDelete<char>(string);
+
+						break;
+					case 5: break; //do nothing. not interested in this type of data, which is memory intensive.
+					case 6: break; //do nothing. not interested in this type of data, which is memory intensive.
+					case 7: break; //do nothing. not interested in this type of data, which is memory intensive.
+					case 8: break; //do nothing. not interested in this type of data, which is memory intensive.
+					case 9:
+							  ISSM_MPI_Bcast(&numstrings,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
+							  /*Now allocate string array: */
+							  if(numstrings){
+								  strings=xNew<char*>(numstrings);
+								  for(int i=0;i<numstrings;i++)strings[i]=NULL;
+
+								  /*Go through strings, and read: */
+								  for(int i=0;i<numstrings;i++){
+
+									  ISSM_MPI_Bcast(&string_size,1,ISSM_MPI_INT,0,IssmComm::GetComm()); 
+									  if(string_size){
+										  string=xNew<char>((string_size+1));
+										  string[string_size]='\0';
+										  ISSM_MPI_Bcast(string,string_size,ISSM_MPI_CHAR,0,IssmComm::GetComm()); 
+									  }
+									  else{
+										  string=xNew<char>(1);
+										  string[0]='\0';
+									  }
+									  strings[i]=string;
+								  }
+							  }
+
+							  /*Add strings to parameters: */
+							  this->AddConstant(new IoConstant(strings,numstrings,record_name));
+
+							  /*Free string*/
+							  for(int i=0;i<numstrings;i++) xDelete<char>(strings[i]);
+							  xDelete<char*>(strings);
+							  break;
+					default: 
+							  _error_("unknown record type:" << record_code); 
+							  break;
 				}
-
+				xDelete<char>(record_name);
 			}
 		}