Index: issm/trunk-jpl/test/NightlyRun/test126.py
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test126.py	(revision 19338)
+++ issm/trunk-jpl/test/NightlyRun/test126.py	(revision 20957)
@@ -38,34 +38,34 @@
 		1e-13,1e-13,1e-13,1e-13,1e-13,1e-13]
 field_values=[\
-		md2.results.TransientSolution[5].Vx-md.results.TransientSolution[0].Vx,\
-		md2.results.TransientSolution[5].Vy-md.results.TransientSolution[0].Vy,\
-		md2.results.TransientSolution[5].Vel-md.results.TransientSolution[0].Vel,\
-		md2.results.TransientSolution[5].TotalSmb-md.results.TransientSolution[0].TotalSmb,\
-		md2.results.TransientSolution[5].Base-md.results.TransientSolution[0].Base,\
-		md2.results.TransientSolution[5].Surface-md.results.TransientSolution[0].Surface,\
-		md2.results.TransientSolution[5].Thickness-md.results.TransientSolution[0].Thickness,\
-		md2.results.TransientSolution[5].IceVolume-md.results.TransientSolution[0].IceVolume,\
-		md2.results.TransientSolution[5].Temperature-md.results.TransientSolution[0].Temperature,\
-		md2.results.TransientSolution[5].Pressure-md.results.TransientSolution[0].Pressure,\
-		md2.results.TransientSolution[6].Vx-md.results.TransientSolution[1].Vx,\
-		md2.results.TransientSolution[6].Vy-md.results.TransientSolution[1].Vy,\
-		md2.results.TransientSolution[6].Vel-md.results.TransientSolution[1].Vel,\
-		md2.results.TransientSolution[6].TotalSmb-md.results.TransientSolution[1].TotalSmb,\
-		md2.results.TransientSolution[6].Base-md.results.TransientSolution[1].Base,\
-		md2.results.TransientSolution[6].Surface-md.results.TransientSolution[1].Surface,\
-		md2.results.TransientSolution[6].Thickness-md.results.TransientSolution[1].Thickness,\
-		md2.results.TransientSolution[6].IceVolume-md.results.TransientSolution[1].IceVolume,\
-		md2.results.TransientSolution[6].Temperature-md.results.TransientSolution[1].Temperature,\
-		md2.results.TransientSolution[6].Pressure-md.results.TransientSolution[1].Pressure,\
-		md2.results.TransientSolution[7].Vx-md.results.TransientSolution[2].Vx,\
-		md2.results.TransientSolution[7].Vy-md.results.TransientSolution[2].Vy,\
-		md2.results.TransientSolution[7].Vel-md.results.TransientSolution[2].Vel,\
-		md2.results.TransientSolution[7].TotalSmb-md.results.TransientSolution[2].TotalSmb,\
-		md2.results.TransientSolution[7].Base-md.results.TransientSolution[2].Base,\
-		md2.results.TransientSolution[7].Surface-md.results.TransientSolution[2].Surface,\
-		md2.results.TransientSolution[7].Thickness-md.results.TransientSolution[2].Thickness,\
-		md2.results.TransientSolution[7].IceVolume-md.results.TransientSolution[2].IceVolume,\
-		md2.results.TransientSolution[7].Temperature-md.results.TransientSolution[2].Temperature,\
-		md2.results.TransientSolution[7].Pressure-md.results.TransientSolution[2].Pressure\
+		md2.results.TransientSolution[5].Vx-md.results.TransientSolution[5]\.Vx,\
+		md2.results.TransientSolution[5].Vy-md.results.TransientSolution[5]\.Vy,\
+		md2.results.TransientSolution[5].Vel-md.results.TransientSolution[5]\.Vel,\
+		md2.results.TransientSolution[5].TotalSmb-md.results.TransientSolution[5]\.TotalSmb,\
+		md2.results.TransientSolution[5].Base-md.results.TransientSolution[5]\.Base,\
+		md2.results.TransientSolution[5].Surface-md.results.TransientSolution[5]\.Surface,\
+		md2.results.TransientSolution[5].Thickness-md.results.TransientSolution[5]\.Thickness,\
+		md2.results.TransientSolution[5].IceVolume-md.results.TransientSolution[5]\.IceVolume,\
+		md2.results.TransientSolution[5].Temperature-md.results.TransientSolution[5]\.Temperature,\
+		md2.results.TransientSolution[5].Pressure-md.results.TransientSolution[5]\.Pressure,\
+		md2.results.TransientSolution[6].Vx-md.results.TransientSolution[6]\.Vx,\
+		md2.results.TransientSolution[6].Vy-md.results.TransientSolution[6]\.Vy,\
+		md2.results.TransientSolution[6].Vel-md.results.TransientSolution[6]\.Vel,\
+		md2.results.TransientSolution[6].TotalSmb-md.results.TransientSolution[6]\.TotalSmb,\
+		md2.results.TransientSolution[6].Base-md.results.TransientSolution[6]\.Base,\
+		md2.results.TransientSolution[6].Surface-md.results.TransientSolution[6]\.Surface,\
+		md2.results.TransientSolution[6].Thickness-md.results.TransientSolution[6]\.Thickness,\
+		md2.results.TransientSolution[6].IceVolume-md.results.TransientSolution[6]\.IceVolume,\
+		md2.results.TransientSolution[6].Temperature-md.results.TransientSolution[6]\.Temperature,\
+		md2.results.TransientSolution[6].Pressure-md.results.TransientSolution[6]\.Pressure,\
+		md2.results.TransientSolution[7].Vx-md.results.TransientSolution[7]\.Vx,\
+		md2.results.TransientSolution[7].Vy-md.results.TransientSolution[7]\.Vy,\
+		md2.results.TransientSolution[7].Vel-md.results.TransientSolution[7]\.Vel,\
+		md2.results.TransientSolution[7].TotalSmb-md.results.TransientSolution[7]\.TotalSmb,\
+		md2.results.TransientSolution[7].Base-md.results.TransientSolution[7]\.Base,\
+		md2.results.TransientSolution[7].Surface-md.results.TransientSolution[7]\.Surface,\
+		md2.results.TransientSolution[7].Thickness-md.results.TransientSolution[7]\.Thickness,\
+		md2.results.TransientSolution[7].IceVolume-md.results.TransientSolution[7]\.IceVolume,\
+		md2.results.TransientSolution[7].Temperature-md.results.TransientSolution[7]\.Temperature,\
+		md2.results.TransientSolution[7].Pressure-md.results.TransientSolution[7]\.Pressure\
 		]
 