Index: issm/trunk-jpl/src/m/consistency/ismodelselfconsistent.m
===================================================================
--- issm/trunk-jpl/src/m/consistency/ismodelselfconsistent.m	(revision 20381)
+++ issm/trunk-jpl/src/m/consistency/ismodelselfconsistent.m	(revision 21049)
@@ -44,57 +44,38 @@
 %      [analyses]=AnalysisConfiguration(solutiontype);
 
-switch solutiontype,
-
-	case StressbalanceSolutionEnum(),
-		analyses=[StressbalanceAnalysisEnum();StressbalanceVerticalAnalysisEnum();StressbalanceSIAAnalysisEnum();L2ProjectionBaseAnalysisEnum()];
-
-	case SteadystateSolutionEnum(),
-		analyses=[StressbalanceAnalysisEnum();StressbalanceVerticalAnalysisEnum();StressbalanceSIAAnalysisEnum();L2ProjectionBaseAnalysisEnum();ThermalAnalysisEnum();MeltingAnalysisEnum();EnthalpyAnalysisEnum()];
-
-	case ThermalSolutionEnum(),
-		analyses=[EnthalpyAnalysisEnum;ThermalAnalysisEnum();MeltingAnalysisEnum()];
-
-	case MasstransportSolutionEnum(),
-		analyses=[MasstransportAnalysisEnum()];
-
-	case BalancethicknessSolutionEnum(),
-		analyses=[BalancethicknessAnalysisEnum()];
-
-	case Balancethickness2SolutionEnum(),
-		analyses=[Balancethickness2AnalysisEnum()];
-
-	case BalancethicknessSoftSolutionEnum(),
-		analyses=[BalancethicknessAnalysisEnum()];
-
-	case BalancevelocitySolutionEnum(),
-		analyses=[BalancevelocityAnalysisEnum()];
-
-	case SurfaceSlopeSolutionEnum(),
-		analyses=[L2ProjectionBaseAnalysisEnum()];
-
-	case BedSlopeSolutionEnum(),
-		analyses=[L2ProjectionBaseAnalysisEnum()];
-
-	case GiaSolutionEnum(),
-		analyses=[GiaAnalysisEnum()];
-
-	case TransientSolutionEnum(),
-		analyses=[StressbalanceAnalysisEnum();StressbalanceVerticalAnalysisEnum();StressbalanceSIAAnalysisEnum();L2ProjectionBaseAnalysisEnum();ThermalAnalysisEnum();MeltingAnalysisEnum();EnthalpyAnalysisEnum();MasstransportAnalysisEnum();HydrologySommersAnalysisEnum];
-
-	case FlaimSolutionEnum(),
-		analyses=[FlaimAnalysisEnum()];
-
-	case SealevelriseSolutionEnum(),
-		analyses=[SealevelriseAnalysisEnum()];
-
-	case HydrologySolutionEnum(),
-		analyses=[L2ProjectionBaseAnalysisEnum();HydrologyShreveAnalysisEnum();HydrologyDCInefficientAnalysisEnum();HydrologyDCEfficientAnalysisEnum()];
-	
-	case DamageEvolutionSolutionEnum(),
-		analyses=[DamageEvolutionAnalysisEnum()];
-
-	otherwise
-		error('%s%s%s',' solution type: ',EnumToString(solutiontype),' not supported yet!');
-
+	if strcmp(solutiontype,'StressbalanceSolution')
+		analyses={'StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis'};
+	elseif strcmp(solutiontype,'SteadystateSolution')
+		analyses={'StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis','ThermalAnalysis','MeltingAnalysis','EnthalpyAnalysis'};
+	elseif strcmp(solutiontype,'ThermalSolution')
+		analyses={'EnthalpyAnalysis','ThermalAnalysis','MeltingAnalysis'};
+	elseif strcmp(solutiontype,'MasstransportSolution')
+		analyses={'MasstransportAnalysis'};
+	elseif strcmp(solutiontype,'BalancethicknessSolution')
+		analyses={'BalancethicknessAnalysis'};
+	elseif strcmp(solutiontype,'Balancethickness2Solution')
+		analyses={'Balancethickness2Analysis'};
+	elseif strcmp(solutiontype,'BalancethicknessSoftSolution')
+		analyses={'BalancethicknessAnalysis'};
+	elseif strcmp(solutiontype,'BalancevelocitySolution')
+		analyses={'BalancevelocityAnalysis'};
+	elseif strcmp(solutiontype,'SurfaceSlopeSolution')
+		analyses={'L2ProjectionBaseAnalysis'};
+	elseif strcmp(solutiontype,'BedSlopeSolution')
+		analyses={'L2ProjectionBaseAnalysis'};
+	elseif strcmp(solutiontype,'GiaSolution')
+		analyses={'GiaAnalysis'};
+	elseif strcmp(solutiontype,'TransientSolution')
+		analyses={'StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis','ThermalAnalysis','MeltingAnalysis','EnthalpyAnalysis','MasstransportAnalysis','HydrologySommersAnalysis'};
+	elseif strcmp(solutiontype,'FlaimSolution')
+		analyses={'FlaimAnalysis'};
+	elseif strcmp(solutiontype,'SealevelriseSolution')
+		analyses={'SealevelriseAnalysis'};
+	elseif strcmp(solutiontype,'HydrologySolution')
+		analyses={'L2ProjectionBaseAnalysis','HydrologyShreveAnalysis','HydrologyDCInefficientAnalysis','HydrologyDCEfficientAnalysis'};
+	elseif strcmp(solutiontype,'DamageEvolutionSolution')
+		analyses={'DamageEvolutionAnalysis'};
+	else
+		error(' solution type: %s' , solutiontype, ' not supported yet!');
 	end
 end % }}}