Index: issm/trunk-jpl/src/m/consistency/ismodelselfconsistent.js
===================================================================
--- issm/trunk-jpl/src/m/consistency/ismodelselfconsistent.js	(revision 20259)
+++ issm/trunk-jpl/src/m/consistency/ismodelselfconsistent.js	(revision 21065)
@@ -10,5 +10,5 @@
 	//Get solution and associated analyses
 	solution=md.priv.solution;
-	if(typeof solution != 'number')throw Error('ismodelselfconsistent: did not provide solution type in the private class!');
+	if(typeof solution !== 'string')throw Error('ismodelselfconsistent: did not provide correct solution type in the private class!');
 	
 	var analyses = AnalysisConfiguration(solution);
@@ -44,72 +44,71 @@
 
 	var analyses=[];
-	switch (solutiontype){
-
-		case StressbalanceSolutionEnum():
-			analyses=[StressbalanceAnalysisEnum(),StressbalanceVerticalAnalysisEnum(),StressbalanceSIAAnalysisEnum(),L2ProjectionBaseAnalysisEnum()];
+		
+	if(solutiontype === 'StressbalanceSolution'){
+			analyses=['StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis'];
 			break;
 
-		case SteadystateSolutionEnum():
-			analyses=[StressbalanceAnalysisEnum(),StressbalanceVerticalAnalysisEnum(),StressbalanceSIAAnalysisEnum(),L2ProjectionBaseAnalysisEnum(),ThermalAnalysisEnum(),MeltingAnalysisEnum()];
+		}else if(solutiontype ==='SteadystateSolution'){
+			analyses=['StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis','ThermalAnalysis','MeltingAnalysis'];
 			break;
 
-		case ThermalSolutionEnum():
-			analyses=[EnthalpyAnalysisEnum(),ThermalAnalysisEnum(),MeltingAnalysisEnum()];
+		}else if(solutiontype ==='ThermalSolution'){
+			analyses=['EnthalpyAnalysis','ThermalAnalysis','MeltingAnalysis'];
 			break;
 
-		case MasstransportSolutionEnum():
-			analyses=[MasstransportAnalysisEnum()];
+		}else if(solutiontype ==='MasstransportSolution'){
+			analyses=['MasstransportAnalysis'];
 			break;
 
-		case BalancethicknessSolutionEnum():
-			analyses=[BalancethicknessAnalysisEnum()];
+		}else if(solutiontype ==='BalancethicknessSolution'){
+			analyses=['BalancethicknessAnalysis'];
 			break;
 
-		case Balancethickness2SolutionEnum():
-			analyses=[Balancethickness2AnalysisEnum()];
+		}else if(solutiontype ==='Balancethickness2Solution'){
+			analyses=['Balancethickness2Analysis'];
 			break;
 
-		case BalancethicknessSoftSolutionEnum():
-			analyses=[BalancethicknessAnalysisEnum()];
+		}else if(solutiontype ==='BalancethicknessSoftSolution'){
+			analyses=['BalancethicknessAnalysis'];
 			break;
 
-		case BalancevelocitySolutionEnum():
-			analyses=[BalancevelocityAnalysisEnum()];
+		}else if(solutiontype ==='BalancevelocitySolution'){
+			analyses=['BalancevelocityAnalysis'];
 			break;
 
-		case SurfaceSlopeSolutionEnum():
-			analyses=[L2ProjectionBaseAnalysisEnum()];
+		}else if(solutiontype ==='SurfaceSlopeSolution'){
+			analyses=['L2ProjectionBaseAnalysis'];
 			break;
 
-		case BedSlopeSolutionEnum():
-			analyses=[L2ProjectionBaseAnalysisEnum()];
+		}else if(solutiontype ==='BedSlopeSolution'){
+			analyses=['L2ProjectionBaseAnalysis'];
 			break;
 
-		case GiaSolutionEnum():
-			analyses=[GiaAnalysisEnum()];
+		}else if(solutiontype ==='GiaSolution'){
+			analyses=['GiaAnalysis'];
 			break;
 
-		case TransientSolutionEnum():
-			analyses=[StressbalanceAnalysisEnum(),StressbalanceVerticalAnalysisEnum(),StressbalanceSIAAnalysisEnum(),L2ProjectionBaseAnalysisEnum(),ThermalAnalysisEnum(),MeltingAnalysisEnum(),EnthalpyAnalysisEnum(),MasstransportAnalysisEnum(),HydrologySommersAnalysisEnum];
+		}else if(solutiontype ==='TransientSolution'){
+			analyses=['StressbalanceAnalysis','StressbalanceVerticalAnalysis','StressbalanceSIAAnalysis','L2ProjectionBaseAnalysis','ThermalAnalysis','MeltingAnalysis','EnthalpyAnalysis','MasstransportAnalysis','HydrologySommersAnalysis'];
 			break;
 
-		case FlaimSolutionEnum():
-			analyses=[FlaimAnalysisEnum()];
+		}else if(solutiontype ==='FlaimSolution'){
+			analyses=['FlaimAnalysis'];
 			break;
 	
-		case SealevelriseSolutionEnum():
-			analyses=[SealevelriseAnalysisEnum()];
+		}else if(solutiontype ==='SealevelriseSolution'){
+			analyses=['SealevelriseAnalysis'];
 			break;
 
-		case HydrologySolutionEnum():
-			analyses=[L2ProjectionBaseAnalysisEnum(),HydrologyShreveAnalysisEnum(),HydrologyDCInefficientAnalysisEnum(),HydrologyDCEfficientAnalysisEnum()];
+		}else if(solutiontype ==='HydrologySolution'){
+			analyses=['L2ProjectionBaseAnalysis','HydrologyShreveAnalysis','HydrologyDCInefficientAnalysis','HydrologyDCEfficientAnalysis'];
 			break;
 
-		case DamageEvolutionSolutionEnum():
-			analyses=[DamageEvolutionAnalysisEnum()];
+		}else if(solutiontype ==='DamageEvolutionSolution'){
+			analyses=['DamageEvolutionAnalysis'];
 			break;
-
-		default:
-			throw Error(sprintf("%s%s%s\n",' solution type: ',EnumToString(solutiontype),' not supported yet!'));
+		}else{
+			throw Error(sprintf("%s%s%s\n",' solution type: ',solutiontype,' not supported yet!'));
+		}
 	}
 	return analyses;